/*****************************************************************************/
#include "tex.h"

/*#define SORT_qsort*/
#define SORT_bubble

world *M_LoadWorld(char *file)
{
   FILE *f;
   world *wld;
   char s[1024];
   char ss[256];
   char s1[256];
   char s2[256];
   char s3[256];
   char s4[256];
   char s5[256];
   int num;
   double x,y,z,a;
   int u1,v1;
   int u2,v2;
   int u3,v3;
   int i,j,k;
   
   f=fopen(file,"r");
   if(!f)
     {
	fprintf(stderr,"ERROR: Cannot load World file:\n%s\nEXIT...\n",file);
	exit(1);
     }
   wld=(world *)malloc(sizeof(world));
   while((fgets(s,1024,f)!=NULL))
     {
	if (s[0]=='#') continue;
	if (s[0]=='\n') continue;
	if (s[0]=='0') continue;
	if (s[0]==' ') continue;
	sscanf(s,"%s",ss);
	if (!strcmp("points",ss))
	  {
	     sscanf(s,"%s %i",ss,&wld->pnum);
	     wld->pnts=(point *)malloc(sizeof(point)*wld->pnum);
	     continue;
	  }
	if (!strcmp("triangles",ss))
	  {
	     sscanf(s,"%s %i",ss,&wld->tnum);
	     wld->tris=(triangle *)malloc(sizeof(triangle)*wld->tnum);
	     wld->trilist=(int *)malloc(sizeof(int)*wld->tnum);
	     wld->see=(int *)malloc(sizeof(int)*wld->tnum);
	     continue;
	  }
	if (!strcmp("textures",ss))
	  {
	     sscanf(s,"%s %i",ss,&wld->inum);
	     wld->imgs=(texture **)malloc(sizeof(texture *)*wld->inum);
	     continue;
	  }
	if (!strcmp("normals",ss))
	  {
	     sscanf(s,"%s %i",ss,&wld->nnum);
	     wld->norms=(normal *)malloc(sizeof(normal)*wld->nnum);
	     for (i=0;i<wld->nnum;i++) wld->norms[i].bright=100;
	     continue;
	  }
	if (!strcmp("objects",ss))
	  {
	     sscanf(s,"%s %i",ss,&wld->onum);
	     wld->objs=(group *)malloc(sizeof(group)*wld->onum);
	     continue;
	  }
	if (!strcmp("surfaces",ss))
	  {
	     sscanf(s,"%s %i",ss,&wld->snum);
	     wld->surfs=(surface *)malloc(sizeof(surface)*wld->snum);
	     continue;
	  }
	if (!strcmp("Light",ss))
	  {
	     wld->lt=(light *)malloc(sizeof(light));
	     sscanf(s,"%s %lf %lf %lf %lf",ss,&x,&y,&z,&a);
	     wld->lt->x=x;
	     wld->lt->y=y;
	     wld->lt->z=z;
	     wld->lt->bright=a;
	     continue;
	  }
	if (!strcmp("LightImages",ss))
	  {
	     sscanf(s,"%s %s %s %s",ss,s1,s2,s3);
	     wld->lglow=D_LoadTexture16(s1);
	     wld->lref1=D_LoadTexture16(s2);
	     wld->lref2=D_LoadTexture16(s3);
	     continue;
	  }
	if (!strcmp("Texture",ss))
	  {
	     sscanf(s,"%s %i %s",ss,&num,s1);
	     wld->imgs[num]=D_LoadTexture16(s1);
	     continue;
	  }
	if (!strcmp("Point",ss))
	  {
	     sscanf(s,"%s %i %lf %lf %lf",ss,&num,&x,&y,&z);
	     wld->pnts[num].x=x;
	     wld->pnts[num].y=y;
	     wld->pnts[num].z=z;
	     continue;
	  }
	if (!strcmp("Surface",ss))
	  {
	     sscanf(s,"%s %i %i %i %i %i %i %i %i",
		    ss,&num,&i,&u1,&v1,&u2,&v2,&u3,&v3);
	     wld->surfs[num].tex=wld->imgs[i];
	     wld->surfs[num].p1.u=(u1*(wld->imgs[i]->width-1))>>10;
	     wld->surfs[num].p1.v=(v1*(wld->imgs[i]->height-1))>>10;
	     wld->surfs[num].p2.u=(u2*(wld->imgs[i]->width-1))>>10;
	     wld->surfs[num].p2.v=(v2*(wld->imgs[i]->height-1))>>10;
	     wld->surfs[num].p3.u=(u3*(wld->imgs[i]->width-1))>>10;
	     wld->surfs[num].p3.v=(v3*(wld->imgs[i]->height-1))>>10;
	     continue;
	  }
	if (!strcmp("Triangle",ss))
	  {
	     sscanf(s,"%s %i %i %i %i %i %i %i %i",
		    ss,&num,&u1,&u2,&u3,&i,&v1,&v2,&v3);
	     wld->tris[num].p1=&wld->pnts[u1];
	     wld->tris[num].p2=&wld->pnts[u2];
	     wld->tris[num].p3=&wld->pnts[u3];
	     wld->tris[num].surf=&wld->surfs[i];
	     wld->tris[num].n1=&wld->norms[v1];
	     wld->tris[num].n2=&wld->norms[v2];
	     wld->tris[num].n3=&wld->norms[v3];
	     continue;
	  }
	if (!strcmp("Object",ss))
	  {
	     sscanf(s,"%s %i %i %i %i %i",
		    ss,&num,&u1,&u2,&u3,&v1);
	     wld->objs[num].pnum=u1;
	     wld->objs[num].tnum=u2;
	     wld->objs[num].nnum=u3;
	     wld->objs[num].cnum=v1;
	     wld->objs[num].plist=(point **)malloc(sizeof(point *)*u1);
	     wld->objs[num].tlist=(triangle **)malloc(sizeof(triangle *)*u2);
	     wld->objs[num].nlist=(normal **)malloc(sizeof(normal *)*u3);
	     wld->objs[num].child=(void **)malloc(sizeof(group *)*v1);
	     continue;
	  }
	if (!strcmp("ObjectPos",ss))
	  {
	     sscanf(s,"%s %i %lf %lf %lf",ss,&num,&x,&y,&z);
	     wld->objs[num].loc.x=x;
	     wld->objs[num].loc.y=y;
	     wld->objs[num].loc.z=z;
	     wld->objs[num].wloc.x=x;
	     wld->objs[num].wloc.y=y;
	     wld->objs[num].wloc.z=z;
	     continue;
	  }
	if (!strcmp("ObjectRot",ss))
	  {
	     sscanf(s,"%s %i %lf %lf %lf",ss,&num,&x,&y,&z);
	     wld->objs[num].rot.ax=x;
	     wld->objs[num].rot.ay=y;
	     wld->objs[num].rot.az=z;
	     wld->objs[num].wrot.ax=x;
	     wld->objs[num].wrot.ay=y;
	     wld->objs[num].wrot.az=z;
	     continue;
	  }
	if (!strcmp("ObjectPoint",ss))
	  {
	     sscanf(s,"%s %i %i %i",ss,&num,&i,&u1);
	     wld->objs[num].plist[i]=&wld->pnts[u1];
	     continue;
	  }
	if (!strcmp("ObjectTriangle",ss))
	  {
	     sscanf(s,"%s %i %i %i",ss,&num,&i,&u1);
	     wld->objs[num].tlist[i]=&wld->tris[u1];
	     continue;
	  }
	if (!strcmp("ObjectNormal",ss))
	  {
	     sscanf(s,"%s %i %i %i",ss,&num,&i,&u1);
	     wld->objs[num].nlist[i]=&wld->norms[u1];
	     continue;
	  }
	if (!strcmp("ObjectChild",ss))
	  {
	     sscanf(s,"%s %i %i %i",ss,&num,&i,&u1);
	     wld->objs[num].child[i]=&wld->objs[u1];
	     continue;
	  }
     }
   fclose(f);
   return wld;
}

M_InitObj(group *o)
{
   point p;
   int i;
   
   p.x=o->loc.x;
   p.y=o->loc.y;
   p.z=o->loc.z;
   o->wloc.x=p.x;
   o->wloc.y=p.y;
   o->wloc.z=p.z;
   for(i=0;i<o->pnum;i++)
     {
	M_AddPoint(o->plist[i],&p);
     }
   for(i=0;i<o->cnum;i++)
     {
	M_InitChild(o,o->child[i]);
     }
}

M_InitChild(group *o, group *c)
{
   point p;
   int i;
   
   p.x=o->wloc.x;
   p.y=o->wloc.y;
   p.z=o->wloc.z;
   c->wloc.x=o->wloc.x+c->loc.z;
   c->wloc.y=o->wloc.y+c->loc.y;
   c->wloc.z=o->wloc.z+c->loc.z;
   for(i=0;i<c->pnum;i++)
     {
	M_AddPoint(c->plist[i],&p);
     }
   for(i=0;i<c->cnum;i++)
     {
	M_InitChild(c,c->child[i]);
     }   
}

M_RotateObj(group *o,double ax, double ay, double az)
{
   int i;
   
   o->rot.ax+=ax;
   o->rot.ay+=ay;
   o->rot.az+=az;
   o->wrot.ax+=ax;
   o->wrot.ay+=ay;
   o->wrot.az+=az;
   for(i=0;i<o->pnum;i++)
     {
	M_SubPoint(o->plist[i],&o->wloc);
	M_RotatePoint(o->plist[i],ax,ay,az);
	M_AddPoint(o->plist[i],&o->wloc);
     }
   for(i=0;i<o->nnum;i++)
     {
	M_RotateNormal(o->nlist[i],ax,ay,az);
	o->nlist[i]->bright=-10;
     }
   for (i=0;i<o->cnum;i++)
     {
	M_RotateChild(o,(group *)o->child[i],ax,ay,az);
     }
}

M_RotateChild(group *o, group *c, double ax, double ay, double az)
{
   int i;
   
   M_RotatePoint(&c->loc,ax,ay,az);
   c->wrot.ax+=ax;
   c->wrot.ay+=ay;
   c->wrot.az+=az;
   c->wloc.x=o->wloc.x+c->loc.x;
   c->wloc.y=o->wloc.y+c->loc.y;
   c->wloc.z=o->wloc.z+c->loc.z;
   for(i=0;i<c->pnum;i++)
     {
	M_SubPoint(c->plist[i],&o->wloc);
	M_RotatePoint(c->plist[i],ax,ay,az);
	M_AddPoint(c->plist[i],&o->wloc);
     }
   for(i=0;i<c->nnum;i++)
     {
	M_RotateNormal(c->nlist[i],ax,ay,az);
	c->nlist[i]->bright=-10;
     }
   for (i=0;i<c->cnum;i++)
     {
	M_RotateChild(o,(group *)o->child[i],ax,ay,az);
     }
}

M_CalcTriLighting(triangle *t, int num, light *l, double focus,int *see)
{
   int i;
   
   for(i=0;i<num;i++)
     {
	see[i]=M_CalcLighting(&t[i],l,focus);
     }
}

M_TranslateObj(group *o, point *p)
{
   int i;
   
   o->loc.x+=p->x;
   o->loc.y+=p->y;
   o->loc.z+=p->z;
   o->wloc.x+=p->x;
   o->wloc.y+=p->y;
   o->wloc.z+=p->z;
   for (i=0;i<o->pnum;i++)
     {
	o->plist[i]->x+=p->x;
	o->plist[i]->y+=p->y;
	o->plist[i]->z+=p->z;
     }
   for (i=0;i<o->cnum;i++)
     {
	M_TranslateChild(o,(group *)o->child[i],p);
     }
}

M_TranslateChild(group *o, group *c, point *p)
{
   int i;
   
   o->wloc.x+=p->x;
   o->wloc.y+=p->y;
   o->wloc.z+=p->z;
   for(i=0;i<c->pnum;i++)
     {
	M_AddPoint(c->plist[i],p);
     }
   for (i=0;i<c->cnum;i++)
     {
	M_TranslateChild(o,(group *)o->child[i],p);
     }
}

M_CalcObjNormals(group *o)
{
   int i;
   
   for(i=0;i<o->tnum;i++)
     {
	M_CalcNormal(o->tlist[i]->p2,o->tlist[i]->p3,o->tlist[i]->p1,
		     o->tlist[i]->n1);
	M_CalcNormal(o->tlist[i]->p3,o->tlist[i]->p1,o->tlist[i]->p2,
		     o->tlist[i]->n2);
	M_CalcNormal(o->tlist[i]->p1,o->tlist[i]->p2,o->tlist[i]->p3,
		     o->tlist[i]->n3);
     }
}

M_RotateNormal(normal *p,double ax, double ay, double az)
{
  double xx,yy,zz;
  double x,y,z;

  x=p->x;
  y=p->y;
  z=p->z;

  xx=x*cos(az);
  yy=x*sin(az);
  x=xx+(y*cos(az+M_PI_2));
  y=yy+(y*sin(az+M_PI_2));

  xx=x*cos(ay);
  zz=x*sin(ay);
  x=xx+(z*cos(ay+M_PI_2));
  z=zz+(z*sin(ay+M_PI_2));

  zz=z*cos(ax);
  yy=z*sin(ax);
  z=zz+(y*cos(ax+M_PI_2));
  y=yy+(y*sin(ax+M_PI_2));

  p->x=x;
  p->y=y;
  p->z=z;
}

int M_Compare(const void *a, const void *b)
{
   struct sortlist *x,*y;
   
   x=(struct sortlist *)a;
   y=(struct sortlist *)b;
   if (x->value-y->value>0) return 1;
   else return -1;
}

M_SortTriangles(triangle *tris, int *list, int size)
{
   int i,k;
   struct sortlist *zlist;
   double a,b,c;
#ifdef SORT_bubble
   int sorted=0;
#endif
   
   zlist=(struct sortlist *)malloc(sizeof(struct sortlist)*size);
   for (k=0;k<size;k++)
     {
	zlist[k].index=k;
	a=(tris[k].p1->x+tris[k].p2->x+tris[k].p3->x)/3;
	b=(tris[k].p1->y+tris[k].p2->y+tris[k].p3->y)/3;
	c=(tris[k].p1->z+tris[k].p2->z+tris[k].p3->z)/3;
	zlist[k].value=sqrt(a*a+b*b+c*c);
     }
#ifdef SORT_qsort   
   qsort((void *)zlist,sizeof(struct sortlist),size,M_Compare);
#endif
#ifdef SORT_bubble   
   if (size>1)
     {
	while (!sorted)
	  {
	     sorted=1;
	     for (i=0;i<size-1;i++)
	       {
		  if (zlist[i].value>zlist[i+1].value)
		    {
		       sorted=0;
		       a=zlist[i].value;
		       k=zlist[i].index;
		       zlist[i].value=zlist[i+1].value;
		       zlist[i].index=zlist[i+1].index;
		       zlist[i+1].value=a;
		       zlist[i+1].index=k;
		    }
	       }
	  }
     }
#endif
   for(i=0;i<size;i++)
     {
	list[i]=zlist[i].index;
     }
   free(zlist);
}


M_RotatePoint(point *p,double ax, double ay, double az)
{
  double xx,yy,zz;
  double x,y,z;

  x=p->x;
  y=p->y;
  z=p->z;

  xx=x*cos(az);
  yy=x*sin(az);
  x=xx+(y*cos(az+M_PI_2));
  y=yy+(y*sin(az+M_PI_2));

  xx=x*cos(ay);
  zz=x*sin(ay);
  x=xx+(z*cos(ay+M_PI_2));
  z=zz+(z*sin(ay+M_PI_2));

  zz=z*cos(ax);
  yy=z*sin(ax);
  z=zz+(y*cos(ax+M_PI_2));
  y=yy+(y*sin(ax+M_PI_2));

  p->x=x;
  p->y=y;
  p->z=z;
}

M_RotateLight(light *p,double ax, double ay, double az)
{
  double xx,yy,zz;
  double x,y,z;

  x=p->x;
  y=p->y;
  z=p->z;

  xx=x*cos(az);
  yy=x*sin(az);
  x=xx+(y*cos(az+M_PI_2));
  y=yy+(y*sin(az+M_PI_2));

  xx=x*cos(ay);
  zz=x*sin(ay);
  x=xx+(z*cos(ay+M_PI_2));
  z=zz+(z*sin(ay+M_PI_2));

  zz=z*cos(ax);
  yy=z*sin(ax);
  z=zz+(y*cos(ax+M_PI_2));
  y=yy+(y*sin(ax+M_PI_2));

  p->x=x;
  p->y=y;
  p->z=z;
}

M_CalcNormal(point *p1, point *p2, point *p3, normal *n)
{
   double x1,y1,z1;
   double x2,y2,z2;
   double x,y,z,ln;
   
   x1=p1->x-p3->x;
   y1=p1->y-p3->y;
   z1=p1->z-p3->z;
   x2=p2->x-p3->x;
   y2=p2->y-p3->y;
   z2=p2->z-p3->z;
   x=y1*z2-z1*y2;
   y=z1*x2-x1*z2;
   z=x1*y2-y1*x2;
   ln=sqrt(x*x+y*y+z*z);
   n->x=x/ln;
   n->y=y/ln;
   n->z=z/ln;                                                    
   n->bright=-1;
}

M_CalcLighting(triangle *t, light *l, double focus)
{
   double lx,ly,lz;
   double vx,vy,vz;
   double ln,v;
   double x,y,z;
   int see;
   
  if (t->n1->bright<0)
    {
      lx=l->x-t->p1->x;
      ly=l->y-t->p1->y;
      lz=l->z-t->p1->z;
      ln=sqrt(lx*lx+ly*ly+lz*lz);
      lx/=ln;
      ly/=ln;
      lz/=ln;
      x=t->n1->x;
      y=t->n1->y;
      z=t->n1->z;
      v=(x*lx+y*ly+z*lz);
      if (v<0) v=0;
      t->n1->bright=v*l->bright;
    }
  if (t->n2->bright<0)
    {
      lx=l->x-t->p2->x;
      ly=l->y-t->p2->y;
      lz=l->z-t->p2->z;
      ln=sqrt(lx*lx+ly*ly+lz*lz);
      lx/=ln;
      ly/=ln;
      lz/=ln;
      x=t->n2->x;
      y=t->n2->y;
      z=t->n2->z;
      v=(x*lx+y*ly+z*lz);
      if (v<0) v=0;
      t->n2->bright=v*l->bright;
    }
  if (t->n3->bright<0)
    {
      lx=l->x-t->p3->x;
      ly=l->y-t->p3->y;
      lz=l->z-t->p3->z;
      ln=sqrt(lx*lx+ly*ly+lz*lz);
      lx/=ln;
      ly/=ln;
      lz/=ln;
      x=t->n3->x;
      y=t->n3->y;
      z=t->n3->z;
      v=(x*lx+y*ly+z*lz);
      if (v<0) v=0;
      t->n3->bright=v*l->bright;
    }
   vx=0+t->p1->x;
   vy=0+t->p1->y;
   vz=focus+t->p1->z;
   ln=sqrt(vx*vx+vy*vy+vz*vz);
   vx/=ln;
   vy/=ln;
   vz/=ln;
   x=t->n1->x;
   y=t->n1->y;
   z=t->n1->z;
   v=(x*vx+y*vy+z*vz);
   if (v<0) see=1;
   else see=0;
   return see;
}

int M_AddPoint(point *p, point *offset)
{
   p->x+=offset->x;
   p->y+=offset->y;
   p->z+=offset->z;
}

int M_SubPoint(point *p, point *offset)
{
   p->x-=offset->x;
   p->y-=offset->y;
   p->z-=offset->z;
}

int M_AddLight(light *l, point *offset)
{
   l->x+=offset->x;
   l->y+=offset->y;
   l->z+=offset->z;
}

int M_SubLight(light *l, point *offset)
{
   l->x-=offset->x;
   l->y-=offset->y;
   l->z-=offset->z;
}

