/*****************************************************************************/
#include "tex.h"

X_SetupImage(int w,int h)
{
   xim=XShmCreateImage(disp,vis,depth,ZPixmap,image,&shminfo,w,h);
   if (!xim) 
     fprintf(stderr,"X-Error: unable to create XShm XImage\n");
   shminfo.shmid=shmget(IPC_PRIVATE,
			xim->bytes_per_line*xim->height,
			IPC_CREAT|0777);
   if (shminfo.shmid==-1) 
     fprintf(stderr,"SharedMemory Error: unable to get identifier\n");
   shminfo.shmaddr=xim->data=shmat(shminfo.shmid,0,0);
   if(!XShmAttach(disp,&shminfo))
     fprintf(stderr,"X-Error: unable to attach XShm Shared Memory Segment\n");
}

X_DisplayImage()
{
  XSync(disp,0xff);
  XShmPutImage(disp,win,gc,xim,0,0,0,0,winwidth,winheight,False);
}

X_OpenWindow(int x, int y, int w,int h)
{
  XGCValues gcvals;
  Window root;
  XColor xcl;
  int i;
  int r,g,b;

  disp=XOpenDisplay(NULL);
  if (disp)
    {
      scr=DefaultScreen(disp);
      vis=DefaultVisual(disp,scr);
      root=DefaultRootWindow(disp);
      depth=DefaultDepth(disp,scr);
      win=XCreateSimpleWindow(disp,root,x,y,w,h,0,0,0);
      gc=XCreateGC(disp,win,(unsigned long)0,&gcvals);
      XSetForeground(disp,gc,0);
      XSetBackground(disp,gc,1);
      XMapWindow(disp,win);
      XFlush(disp);
      if (depth==8)
	{
	  /* USE THIS IF I WANT TO BE NICE TO THE USER 
	     AND NOT INSTALL THE COLORMAP
	  cmap=DefaultColormap(disp,scr);
	  */
	  cmap=XCreateColormap(disp,win,vis,AllocNone);
	  for (r=0;r<8;r++)
	    {
	      for(g=0;g<8;g++)
		{
		  for(b=0;b<4;b++)
		    {
		      xcl.red=(unsigned short)((r<<13)|(r<<10)|(r<<7)|(r<<4)|(r<<1)|(r>>2));
		      xcl.green=(unsigned short)((g<<13)|(g<<10)|(g<<7)|(g<<4)|(g<<1)|(g>>2));
		      xcl.blue=(unsigned short)((b<<14)|(b<<12)|(b<<10)|(b<<8)|(b<<6)|(b<<4)|(b<<2)|b);
		      xcl.flags=DoRed|DoGreen|DoBlue;
		      XAllocColor(disp,cmap,&xcl);
		      col_lookup_tab[r][g][b]=xcl.pixel;
		    }
		}
	    }

	  XSetWindowColormap(disp,win,cmap);
	}
      else if(depth==15)
	{
	  printf("32,767 Colours mode is not supported quite yet\n");
	  printf("Sorry. Try 65,536 colours mode for X\n");
	  exit(1);
	}
      else if(depth==16)
	{
	}
      else if(depth==24)
	{
	  printf("24-Bit mode isn't supported yet.\n");
	  printf("Sorry. Try 65,536 colours mode for X\n");
	}
      else
	{
	  printf("Sorry. A screen mode with %i bits per pixel is\n",depth);
	  printf("supported. Currently the supported screen modes are:\n");
	  printf("     65,536 colours\n");
	}
    }
  else
    {
      printf("Cannot open display\n");
      exit(1);
    }
  winwidth=w;
  winheight=h;
}

X_GetWidth()
{
  XWindowAttributes wa;
  
  XGetWindowAttributes(disp,win,&wa);
  return wa.width;
}

X_GetHeight()
{
  XWindowAttributes wa;
  
  XGetWindowAttributes(disp,win,&wa);
  return wa.height;
}












































